using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Diagnostics;
using Syncfusion.Windows.Forms.Grid;
using System.Collections.Specialized;

namespace Parenthese
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
      private System.Windows.Forms.ComboBox _PredefinedShapesComboBox;
      private GridFormulaEngine _Engine;
      private Syncfusion.Windows.Forms.Grid.GridControl _VariablesGrid;
      private Syncfusion.Windows.Forms.Grid.GridControl _CharacteristicGrid;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

         #region Register the Grids
         //register grids 
         _Engine = ((GridFormulaCellModel)
            _VariablesGrid.Model.CellModels["FormulaCell"]).Engine;
         int sheetFamilyID = GridFormulaEngine.CreateSheetFamilyID(); 
         GridFormulaEngine.RegisterGridAsSheet("VariablesGrid", 
            this._VariablesGrid.Model, sheetFamilyID);
         GridFormulaEngine.RegisterGridAsSheet("CharacteristicGrid", 
            this._CharacteristicGrid.Model, sheetFamilyID);


         #endregion

         #region Predefined Shapes list
         // Initialize the choice list for Predefined Shapes combo box.
         this._PredefinedShapesComboBox.Items.AddRange( new object[] {
                                                                        "QUAD1",
                                                                        "QUAD2",
                                                                        "BULLET",
                                                                        "LENS",
                                                                        "TOMATO"});        
         #endregion

         #region Setup VariablesGrid Headers
         this._VariablesGrid[0, 1].Text = "LABEL";
         this._VariablesGrid[0, 2].Text ="VALUE";
         this._VariablesGrid[0, 3].Text = "COMMENTS";

         this._VariablesGrid.BaseStylesMap["Column Header"].StyleInfo.BackColor =  
            Color.FromArgb(213,221,233); //light gray blue 
         this._VariablesGrid.BaseStylesMap["Header"].StyleInfo.BackColor =  
            Color.FromArgb(213,221,233); //light gray blue 
         this._VariablesGrid.BaseStylesMap["Row Header"].StyleInfo.BackColor =  
            Color.FromArgb(213,221,233); //light gray blue 

         this._VariablesGrid.Model.RowHeights.ResizeToFit(
            GridRangeInfo.Table(), GridResizeToFitOptions.IncludeHeaders);
         //this._TripTimeGridControl.Model.ColWidths.ResizeToFit(
         //  GridRangeInfo.Table(), GridResizeToFitOptions.IncludeHeaders);
         this._VariablesGrid.ColWidths[3] = 70;     

         #endregion
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
         this._PredefinedShapesComboBox = new System.Windows.Forms.ComboBox();
         this._VariablesGrid = new Syncfusion.Windows.Forms.Grid.GridControl();
         this._CharacteristicGrid = new Syncfusion.Windows.Forms.Grid.GridControl();
         ((System.ComponentModel.ISupportInitialize)(this._VariablesGrid)).BeginInit();
         ((System.ComponentModel.ISupportInitialize)(this._CharacteristicGrid)).BeginInit();
         this.SuspendLayout();
         // 
         // _PredefinedShapesComboBox
         // 
         this._PredefinedShapesComboBox.Location = new System.Drawing.Point(80, 32);
         this._PredefinedShapesComboBox.Name = "_PredefinedShapesComboBox";
         this._PredefinedShapesComboBox.Size = new System.Drawing.Size(121, 21);
         this._PredefinedShapesComboBox.TabIndex = 0;
         this._PredefinedShapesComboBox.SelectedIndexChanged += new System.EventHandler(this._PredefinedShapesComboBox_SelectedIndexChanged);
         // 
         // _VariablesGrid
         // 
         this._VariablesGrid.Location = new System.Drawing.Point(8, 128);
         this._VariablesGrid.Name = "_VariablesGrid";
         this._VariablesGrid.Size = new System.Drawing.Size(552, 152);
         this._VariablesGrid.SmartSizeBox = false;
         this._VariablesGrid.TabIndex = 1;
         this._VariablesGrid.Text = "gridControl1";
         // 
         // _CharacteristicGrid
         // 
         this._CharacteristicGrid.Location = new System.Drawing.Point(24, 320);
         this._CharacteristicGrid.Name = "_CharacteristicGrid";
         this._CharacteristicGrid.Size = new System.Drawing.Size(544, 160);
         this._CharacteristicGrid.SmartSizeBox = false;
         this._CharacteristicGrid.TabIndex = 2;
         this._CharacteristicGrid.Text = "gridControl1";
         // 
         // Form1
         // 
         this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
         this.ClientSize = new System.Drawing.Size(736, 514);
         this.Controls.Add(this._CharacteristicGrid);
         this.Controls.Add(this._VariablesGrid);
         this.Controls.Add(this._PredefinedShapesComboBox);
         this.Name = "Form1";
         this.Text = "Form1";
         ((System.ComponentModel.ISupportInitialize)(this._VariablesGrid)).EndInit();
         ((System.ComponentModel.ISupportInitialize)(this._CharacteristicGrid)).EndInit();
         this.ResumeLayout(false);

      }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

      private void TomatoIntermediateFormula()
      {
         //Ztot = ZReach - ZOffset
         this._Engine.AddNamedRange("Ztot", "=ZREACH - ZOFFSET");
          //  "=" + "ZREACH" + "-" + "ZOFFSET");
       

        // string ShowZReach = (string) _Engine.NamedRanges["ZREACH"];
        // string ShowZOffset = (string) _Engine.NamedRanges["ZOFFSET"];
        // string ShowZtot = (string) _Engine.NamedRanges["ZTOT"];
        // string ZReachText = this._VariablesGrid[2,2].Text;
       //  string ZOffsetText = this._VariablesGrid[4,2].Text;

        // _Engine.FormulaContextCell = "B4";
        // string parsedFormula = _Engine.Parse("=Ztot");
        // string solvedFormula = _Engine.GetValueFromArg(parsedFormula);
        // parsedFormula = _Engine.Parse("=ZREACH - ZOFFSET");
       //  solvedFormula = _Engine.GetValueFromArg(parsedFormula);

        
         //string Value = "=((Ztot / 2 ) ^ 2 + (Ztot / 2 * AspectRatio) ^ 2) / (Ztot * AspectRatio)";
         // made formula simple.
         string Value = "=((Ztot / 2)^2) + (Ztot / 2)";
         bool returnValue = this._Engine.AddNamedRange("Rad", Value);

       
      }

      private void _PredefinedShapesComboBox_SelectedIndexChanged(object sender, System.EventArgs e)
      {
         this._CharacteristicGrid.TableStyle.CellType = "FormulaCell";
         switch (this._PredefinedShapesComboBox.SelectedIndex)
         {
            
            case 4: //Tomato
            {
               this._VariablesGrid[2,1].Text = "ZREACH";
               this._VariablesGrid[2,2].Text = "10";
               this._Engine.AddNamedRange("ZREACH", 
                  "VariablesGrid" + "!" + "$" + "B" + "$" + "2");

               this._VariablesGrid[3,1].Text = "CHAR_ANGLE";
               this._VariablesGrid[3,2].Text = "75";
               this._Engine.AddNamedRange("CHAR_ANGLE", 
                  "VariablesGrid" + "!" + "$" + "B" + "$" + "3");

               this._VariablesGrid[4,1].Text = "ZOFFSET";
               this._VariablesGrid[4,2].Text = "-2";
               this._Engine.AddNamedRange("ZOFFSET", 
                  "VariablesGrid" + "!" + "$" + "B" + "$" + "4");

               this._VariablesGrid[5,1].Text = "ASPECT_RATIO";
               this._VariablesGrid[5,2].Text = "1.5";
               this._Engine.AddNamedRange("ASPECT_RATIO", 
                  "VariablesGrid" + "!" + "$" + "B" + "$" + "5");

               TomatoIntermediateFormula();
              
               // _CharDataGridControl initializing: value columns
              //this._CharDataGridControl[2,2].Text = "=Ch1";
              // this._CharDataGridControl[3,2].Text = "=Ck1";
               this._CharacteristicGrid[4,2].Text = "=Rad";
              // this._CharDataGridControl[5,2].Text = "=StAng1";
              // this._CharDataGridControl[6,2].Text = "=EndAng1";

            

               // _CharDataGridControl initializing : label columns
             //  this._CharDataGridControl[1, 1].Text = _stringTable.GetString("ARC_CARTESIAN");
             //  this._CharDataGridControl[2, 1].Text = _stringTable.GetString("R");
             //  this._CharDataGridControl[3, 1].Text = _stringTable.GetString("X");
               this._CharacteristicGrid[4, 1].Text = "RADIUS";
             //  this._CharDataGridControl[5, 1].Text = _stringTable.GetString("START_ANGLE");
            //   this._CharDataGridControl[6, 1].Text = _stringTable.GetString("END_ANGLE");

                 
               break;
            }
         }
      }
	}
}
